<?php
class TagHandlerBase
{
	function expand($template, $data)
	{
		foreach ($data as $key => $value) 
		{
			$template  = str_replace('{'.$key.'}', $value, $template) ;
			
		}
		return $template;
	}
}

class pctContent extends TagHandlerBase
{
	var $Tag;
	var $LoopCounter;
	function mytagContent()
	{
		;
	}
	
	function getResult($tag, &$CallAgain)
	{
		$this->LoopCounter++;

		if ($this->LoopCounter < intval($tag->Attributes["repeat"]) )
		{
			$CallAgain = true;
		}
		return $this->expand($tag->Content, array('content' => 'ݺ : ' . $this->LoopCounter) );
	}
}
class pctHeader extends TagHandlerBase
{
	var $Tag;
	function mytagHeader()
	{
		;
	}

	function getResult($tag, &$CallAgain)
	{
		if ( 'true' == $tag->Attributes["noexpand"])
		{
			return "Ȯ  ";
		}
		else 
		{
			return $this->expand($tag->Content,  array ( 'title' => 'Hello', 'author' => 'Me') ) ;
		}
	}
}

class pctFooter extends TagHandlerBase
{
	var $Tag;
	function pctHeader()
	{
		;
	}
	function getResult($tag, &$CallAgain)
	{
		return '
<hr />
<p>ۼ:  </p>' ;

	}
} // class pctFooter 

class pctTable extends TagHandlerBase
{
	var $LoopCounter;
	function pctTable()
	{
		$LoopCounter = 0;
	}
	
	function getResult($tag, &$CallAgain)
	{
		$Tpl = new PhpCustomTagParser;
		$Tpl->setTemplate($tag->Content);
		$Tpl->prepare();
		return $Tpl->parse();
	}	
} //class pctTable

class pctTableHeader extends TagHandlerBase
{
	var $LoopCounter;
	function pctTableHeader($params)
	{
		$this->LoopCounter = 0;
		$this->$Params = $params;
	}
	
	function getResult($tag, &$CallAgain)
	{
		$this->LoopCounter++;
		if ($this->LoopCounter < 3) $CallAgain = true;
		$Data = array(
			'1' => 'īװ '. $this->LoopCounter,
			'2' =>''
			);
		
		$Content = $this->expand($tag->Content,  $Data) ;
		$Tpl = new PhpCustomTagParser;
		$Tpl->setTemplate($Content);
		$Tpl->prepare();
		$Tpl->setParam('CurrentHeader', $this->LoopCounter);
		return $Tpl->parse();
	}
} //class pctTableHeader

class pctTableRows extends TagHandlerBase
{
	var $LoopCounter;
	var $Params = array();
	function pctTableRows($params)
	{
		$this->LoopCounter = 0;
		$this->Params = $params;
	}
	
	function getResult($tag, &$CallAgain)
	{
		$this->LoopCounter++;
		$Data = array( '1' => 'Hello' . $this->LoopCounter,
			 '2' => $this->Params['CurrentHeader']
			 );
			 
		if ($this->LoopCounter < 5)
		{
			$CallAgain = true;
		}
			
		return  $this->expand($tag->Content,  $Data );

	}
} //class pctTableRows

class pctDebug extends TagHandlerBase
{
	var $Params = array();
	function pctDebug($params)
	{
		$this->LoopCounter = 0;
		$this->Params = $params;
	}
	function getResult($tag, &$CallAgain)
	{
		ob_start();
		echo $tag->Content . "<hr/><pre>\n";
		print_r( $this->Params);
		echo "</pre>\n<hr/><pre>\n" ;
		print_r( $tag );
		echo "</pre>\n";
		$result = ob_get_contents();
		ob_end_clean();
		return $result;
	}
} // pctDebug
?>