<?
define ("PCT_TEMPLATE", 0);
define ("PCT_HTML", 1);

class pctAttribute
{
	var $Name;
	var $Value;
	function pctAttribute($aName, $aValue)
	{
		$this->Name = $aName;
		$this->Value = $aValue;
	}
}
class pctTag
{
	var $Type;
	var $Name;
	var $Content;
	var $Attributes = array();

	function pctTag($aName, $aType = PCT_TEMPLATE)
	{
		$this->Name = $aName;
		$this->Type = $aType;
	}
	function addAttribute($aName, $aValue)
	{
		$this->Attributes[] = new pctAttribute($aName, $aValue);
	}
} // class pctTag

class pctPage
{
	var $Template;
	var $Tags = array();
	function pctPage()
	{
		;
	}	
	function parse()
	{
		
		$this->Tags[] = new pctTag('Hello');
		$this->Tags[] = new pctTag('', PCT_HTML );
		$this->Tags[] = new pctTag('World');
		$this->Tags[1]->Content = '<p>foobar</p>';
		$this->Tags[0]->addAttribute('show', 'hi there');
	}	 
} // class pctPage

class pctPageProcessor
{
	var $Tags = array();
	var $TemplateFilename;
	var $CodebehindFilename;
	var $Result;
	var $Page;
	var $PageContext;

	function pctPageProcessor($aPageName, $aTemplatePostfix = '.tpl' , 
		$aCodebehindPostfix = '.php' 
	)
	{
		$this->TemplateFilename = $aPageName . $aTemplatePostfix;
		$this->CodebehindFilename = $aPageName .$aCodebehindPostfix;

		$this->Page = new pctPage($aPageName, $aTemplatePostfix , 
			$aCodebehindPostfix) ;
	}
	
	function doProcess()
	{
		$this->loadTemplateFile();
		$this->includeCodebehindFile();
	}
	
	function loadTemplateFile()
	{
		$this->page->Template =  implode( "\r\n", file($this->TemplateFilename)  );
	}
	function includeCodebehindFile()
	{
		require( $this->CodebehindFile );
	}
} // class pctPageProcessor

?>